



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>bzoj 3931: [CQOI2015]网络吞吐量  -- 最短路+网络流</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">bzoj 3931: [CQOI2015]网络吞吐量  -- 最短路+网络流</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-15 20:53:15 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>3931: [CQOI2015]网络吞吐量</h2>
<p>Time Limit:&nbsp;10 Sec&nbsp;&nbsp;Memory Limit:&nbsp;512 MB</p>
<h2>Description</h2>
<div>
<p>路由是指通过计算机网络把信息从源地址传输到目的地址的活动，也是计算机网络设计中的重点和难点。网络中实现路由转发的硬件设备称为路由器。为了使数据包最快的到达目的地，路由器需要选择最优的路径转发数据包。例如在常用的路由算法OSPF(开放式最短路径优先)中，路由器会使用经典的Dijkstra算法计算最短路径，然后尽量沿最短路径转发数据包。现在，若已知一个计算机网络中各路由器间的连接情况，以及各个路由器的最大吞吐量（即每秒能转发的数据包数量），假设所有数据包一定沿最短路径转发，试计算从路由器1到路由器n的网络的最大吞吐量。计算中忽略转发及传输的时间开销，不考虑链路的带宽限制，即认为数据包可以瞬间通过网络。路由器1到路由器n作为起点和终点，自身的吞吐量不用考虑，网络上也不存在将1和n直接相连的链路。</p>
<div>&nbsp;</div>
</div>
<h2>Input</h2>
<div>
<p>输入文件第一行包含两个空格分开的正整数n和m，分别表示路由器数量和链路的数量。网络中的路由器使用1到n编号。接下来m行，每行包含三个空格分开的正整数a、b和d，表示从路由器a到路由器b存在一条距离为d的双向链路。 接下来n行，每行包含一个正整数c，分别给出每一个路由器的吞吐量。</p>
<div>&nbsp;</div>
</div>
<h2>Output</h2>
<div>
<p>输出一个整数，为题目所求吞吐量。</p>
<div>&nbsp;</div>
</div>
<h2>Sample Input</h2>
<div>7 10<br />
1 2 2<br />
1 5 2<br />
2 4 1<br />
2 3 3<br />
3 7 1<br />
4 5 4<br />
4 3 1<br />
4 6 1<br />
5 6 2<br />
6 7 1<br />
1<br />
100<br />
20<br />
50<br />
20<br />
60<br />
1
</div>
<h2>Sample Output</h2>
<div>70</div>
<h2>HINT</h2>
<div>
<p>对于100%的数据，n&le;500，m&le;100000，d,c&le;10^9</p>
</div>
<h2>Source</h2>
<p>跑完最短路之后重新建边，然后就是裸的网络流</p>
<p>注意一定要开long long，并且inf一定要大。。。T_T</p>
<div>
<pre class="prettyprint linenums">#include&lt;map&gt;<br />
#include&lt;cmath&gt;<br />
#include&lt;queue&gt;<br />
#include&lt;cstdio&gt;<br />
#include&lt;cstring&gt;<br />
#include&lt;iostream&gt;<br />
#include&lt;algorithm&gt;<br />
using namespace std;<br />
#define ll long long<br />
#define pa pair&lt;ll,ll&gt;<br />
#define N 410010<br />
#define M 510<br />
inline ll read()<br />
{<br />
    ll x=,f=;char ch=getchar();<br />
    while(ch&lt;''||ch&gt;''){if(ch=='-')f=-;ch=getchar();}<br />
    while(ch&gt;=''&amp;&amp;ch&lt;=''){x=x*+ch-'';ch=getchar();}<br />
    return x*f;<br />
}<br />
const ll inf=(1LL&lt;&lt;)-;<br />
ll cnt,lj[N],fro[N],to[N],v[N];<br />
inline void add(ll a,ll b,ll c){fro[++cnt]=lj[a];to[cnt]=b;v[cnt]=c;lj[a]=cnt;}<br />
inline void ins(ll a,ll b,ll c){add(a,b,c);add(b,a,);}<br />
ll dis[N],ans;<br />
bool vs[N];<br />
void dijsktra()<br />
{<br />
    priority_queue&lt;pa,vector&lt;pa&gt;,greater&lt;pa&gt; &gt;q;<br />
    memset(dis,0x3f,sizeof(dis));<br />
    dis[]=;<br />
    q.push(make_pair(,));<br />
    ll u,et;<br />
    while(!q.empty())<br />
    {<br />
        u=q.top().second;q.pop();<br />
        if(vs[u]) continue;<br />
        vs[u]=;<br />
        for(int i=lj[u];i;i=fro[i])<br />
        {<br />
            et=to[i];<br />
            if(dis[et]&gt;dis[u]+v[i])<br />
            {<br />
                dis[et]=dis[u]+v[i];<br />
                q.push(make_pair(dis[et],et));<br />
            }<br />
        }<br />
    }<br />
}<br />
ll n,m;<br />
queue&lt;ll&gt;q;<br />
bool bfs()<br />
{<br />
    memset(dis,,sizeof(dis));<br />
    dis[]=;<br />
    q.push();<br />
    ll u;<br />
    while(!q.empty())<br />
    {<br />
        u=q.front();q.pop();<br />
        for(int i=lj[u];i;i=fro[i])<br />
        {<br />
            if(v[i]&amp;&amp;!dis[to[i]])<br />
            {<br />
                dis[to[i]]=dis[u]+;<br />
                q.push(to[i]);<br />
            }<br />
        }<br />
    }<br />
    return dis[n]?:;<br />
}<br />
ll dfs(ll x,ll p)<br />
{<br />
    if(x==n||p==) return p;<br />
    ll tmp=,tp;<br />
    for(int i=lj[x];i;i=fro[i])<br />
    {<br />
        if(v[i]&amp;&amp;dis[to[i]]==dis[x]+)<br />
        {<br />
            tp=dfs(to[i],min(p-tmp,v[i]));<br />
            v[i]-=tp;<br />
            v[i^]+=tp;<br />
            tmp+=tp;<br />
            if(p==tmp) return tmp;<br />
        }<br />
    }<br />
    if(tmp==) dis[x]=;<br />
    return tmp;<br />
}<br />
ll x[N],y[N],d[N],c;<br />
int main()<br />
{<br />
    n=read();m=read();<br />
    for(int i=;i&lt;=m;i++)<br />
    {<br />
        x[i]=read();y[i]=read();d[i]=read();<br />
        add(x[i],y[i],d[i]);add(y[i],x[i],d[i]);<br />
    }<br />
    dijsktra();<br />
    memset(lj,,sizeof(lj));cnt=;<br />
    for(int i=;i&lt;=m;i++)<br />
    {<br />
        if(dis[x[i]]+d[i]==dis[y[i]]) ins(x[i]+n,y[i],inf);<br />
        if(dis[y[i]]+d[i]==dis[x[i]]) ins(y[i]+n,x[i],inf);<br />
    }<br />
    for(int i=;i&lt;=n;i++){c=read();ins(i,i+n,(i==)||(i==n)?inf:c);}<br />
    n&lt;&lt;=;<br />
    while(bfs()) ans+=dfs(,inf);<br />
    printf("%lld\n",ans);<br />
    return ;<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4yng5q.html">Microsoft SQL Server 2008 R2 安装卸载</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvd7dxq.html">伪随机数&lpar;线性同余法&rpar;C语言</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qngnwg8.html">使用Application Insights 做分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy3vjg8.html">mysql 命令管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1xw5z8.html">字符串数组&lpar;String &lbrack;&rsqb;&rpar; 去掉重复值的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4vgonq.html">composer安装fxp插件时候提示内存不足且没有交换空间的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96wo4nq.html">CSS 超出隐藏问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx31ojq.html">毫无保留开源我写的：IOS Android Ipad 多点触摸通用js 库</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2p45w8.html">超链接的那些事&lpar;三&rpar;&colon; 属性target</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j07v5wq.html">poj 2240 Arbitrage （Floyd）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y0el3q.html">poj3696：同余方程，欧拉定理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojz1wpq.html">RTMP、HTTP-FLV、HLS，你了解常见的三大直播协议吗</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zrmvj9.html">使用mpvue开发小程序教程（三）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj7x0y8.html">OpenDialog文件多选</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7omr718.html">64位Win7系统nbtstat 问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m25zg6q.html">vue核心之虚拟DOM</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjy20r9.html">ubuntu下没有ping命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmj3w49.html">Linux shell（1）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qve24ej9.html">Atitti 固化数据库表结构方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmvd2w9.html">ES6-fetch</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93pe6vz8.html">转：字符集和字符编码（Charset &amp;amp&semi; Encoding）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8koy6n5q.html">C&plus;&plus;循环链表解决约瑟夫环问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1gd009.html">Math类的数学计算功能</a>
			</li>
						<li><a href="https://www.batexi.com/a/8koy6w3q.html">java基础12 抽象类（及关键字：abstract）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvmj4gq.html">LeetCode765&period; Couples Holding Hands</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4prv3nq.html">SG函数&lpar;转自百度百科&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdjn46vq.html">开始学习MaxCompute</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rne2nmq.html">MVC &ndash; 5&period;MVC设计模式和&period;NetMVC框架</a>
			</li>
						<li><a href="https://www.batexi.com/a/8emnvyx9.html">AC日记&mdash;&mdash;小A和uim之大逃离 II  洛谷七月月赛</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rnex5mq.html">WERTYU（UVa10082）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
